#include <boost/mpi/environment.hpp>
#include <boost/mpi/communicator.hpp>
#include <boost/mpi.hpp>
#include <boost/serialization/vector.hpp>
#include <boost/serialization/access.hpp>
#include <boost/serialization/string.hpp>
#include <iostream>
#include <vector>
#include <sstream>
#include <boost/array.hpp>
#include <boost/mpi/collectives.hpp>

namespace mpi = boost::mpi;
using namespace std;

class Stat
{
public:
	int id;
	int br_poena;
	int br_skokova;
	int br_asistencija;
public :
	Stat(int id1,int br_poena1,int br_skokova1,int br_asistencija1)
	{
		id=id1;
		br_poena=br_poena1;
		br_skokova=br_skokova1;
		br_asistencija=br_asistencija1;
		}
public:
	friend class boost::serialization::access;
	template<class Archive>
	void serialize(Archive & ar, const unsigned int version)
	{
	  ar & id;
	  ar & br_poena;
	  ar & br_skokova;
	  ar & br_asistencija;
	}
	}
class Kosarkas
{	public:
		int id;
		string ime;
		int br_poena;
		int br_asistencija;
		int br_skokova;
		int br_utakmica;
	public:
		Kosarkas(){}
		Kosarkas(int id1,string ime)
		{
			id=id1;
			strcpy(ime,id1);
			}
	}
	public:
		void AddStat(Stat o)
		{
			if(id==o.id){
			br_poena+=o.br_poena;
			br_asistencija+=o.br_asistencija;
			br_skokova+=o.br_skokova;
			}
			}
		int IsPlayer(int broj)
		{
			if(id==broj) return 1;
			else return 0;
			}
		//ovo je umesto operatora >
		int jeVeci(Kosarkas k)
		{
			int mvp=(br_poena*2+br_asistencija*3+br_skokova*3)/br_utakmica;
			int mvp1=(k.br_poena*2+k.br_asistencija*3+k.br_skokova*3)/k.br_utakmica;
			if(mvp>mvp1) return 1;
			else return 0;
			}
int main(int argc, char* argv[]) 
{
  mpi::environment env(argc, argv);
  mpi::communicator world;
  Vector stat;
  Vector kos;
  Vector kos1;
  int i;
  int id;
  string ime;
  int poeni;
  int asistencije;
  int skokovi;
  int utakmica;
  int c;
  int u;
  int nstat;
  if(world.rank==0)
  {
	  scanf("%d",&n);
	  for(i=0;i<n;i++){
		scanf("%d",&id);
		scanf("%s",ime);
		scanf("%d",&poeni);
		scanf("%d",&assistencije);
		scanf("%d",&skokovi);
		scanf("%d",&utakmica);
		Kosarkas k(id,ime,poeni,assistencije,skokovi,utakmica);
		kos.pushBack(k);
	}
		c=n/world.size;
		scatter(world,kos,c,kos1,u,0);
		
		scanf("%d",&nstat);
		for(i=0;i<nstat;i++)
		{
			scanf("%d",&id);
			scanf("%d",&poeni);
			scanf("%d",&asistencije);
			scanf("%d",&skokovi);
			Stat s(id,poeni,asistencije,skokovi);
			stat.pushBack(k);
			
			}
		broadcast(world,stat,nstat,0);
	  }


for(i=0;i<u;i++)
{
	for(j=0;j<nstat;j++)
	{
		kos1[i].AddStat(o[j]);
		}
	}

}
Kosarkas max;
Kosarkas mvp;
max=kos1[0];
for(i=1;i<u;i++)
{
	if(max.jeVeci(kos1[i])==0) max=jeVeci;
	}

reduce(world,max,mvp,MPI_MAX,0);

if(world.rank()==0)
{
	cout << mvp.id <<" " <<mvp.ime << " " << mvp.br_asistencija << " " << mvp.br_poena << " " << mvp.br_skokova <<" " << mvp.br_utakmica 
	}
