#include<mpi.h>
#include<stdio.h>
#include<stdlib.h>

typedef struct {
	int trenutnoOruzje; // 0-papir; 1-kamen; 2-makaze
	int brPobeda = 0;
	int brPoraza = 0;
}Igrac;

typedef struct {
	int br_pobedaPapir = 0;
	int br_porazaPapir = 0;
	int br_pobedaKamen = 0;
	int br_porazaKamen = 0;
	int br_pobedaMakaze = 0;
	int br_porazaMakaze = 0;
}Stat;

void OdigrajPotez3(Igrac *PomocnaMatrica,int ID, int k1, int k2, int k3, int *PapirPobedaProces, int *PapirPorazProces, int *KamenPobedaProces, int *KamenPorazProces, int *MakazePobedaProces, int *MakazePorazProces)
{
	switch(PomocnaMatrica[ID].trenutnoOruzje)
			{
				case: 0; // papir
					switch(PomocnaMatrica[k1].trenutnoOruzje)
					{
						case: 1; PomocnaMatrica[ID].brPobeda++; *PapirPobedaProces++;break;
						case: 2; PomocnaMatrica[ID].brPoraza++; *PapirPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k2].trenutnoOruzje)
					{
						case: 1; PomocnaMatrica[ID].brPobeda++; *PapirPobedaProces++;break;
						case: 2; PomocnaMatrica[ID].brPoraza++; *PapirPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k3].trenutnoOruzje)
					{
						case: 1; PomocnaMatrica[ID].brPobeda++; *PapirPobedaProces++;break;
						case: 2; PomocnaMatrica[ID].brPoraza++; *PapirPorazProces++;break;
						default: ;
					}
				break;
				
				case: 1; // kamen
					switch(PomocnaMatrica[k1].trenutnoOruzje)
					{
						case: 2; PomocnaMatrica[ID].brPobeda++; *KamenPobedaProces++;break;
						case: 0; PomocnaMatrica[ID].brPoraza++; *KamenPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k2].trenutnoOruzje)
					{
						case: 2; PomocnaMatrica[ID].brPobeda++; *KamenPobedaProces++;break;
						case: 0; PomocnaMatrica[ID].brPoraza++; *KamenPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k3].trenutnoOruzje)
					{
						case: 2; PomocnaMatrica[ID].brPobeda++; *KamenPobedaProces++;break;
						case: 0; PomocnaMatrica[ID].brPoraza++; *KamenPorazProces++;break;
						default: ;
					}
				break;
				
				case: 2; //makazice
					switch(PomocnaMatrica[k1].trenutnoOruzje)
					{
						case: 0; PomocnaMatrica[ID].brPobeda++; MakazePobedaProces++;break;
						case: 1; PomocnaMatrica[ID].brPoraza++; MakazePorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k2].trenutnoOruzje)
					{
						case: 0; PomocnaMatrica[ID].brPobeda++; MakazePobedaProces++;break;
						case: 1; PomocnaMatrica[ID].brPoraza++; MakazePorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k3].trenutnoOruzje)
					{
						case: 0; PomocnaMatrica[ID].brPobeda++; MakazePobedaProces++;break;
						case: 1; PomocnaMatrica[ID].brPoraza++; MakazePorazProces++;break;
						default: ;
					}
				break;
				default: ;
			}
}

void OdigrajPotez5(Igrac *PomocnaMatrica,int ID, int k1, int k2, int k3, int k4, int k5,  int *PapirPobedaProces, int *PapirPorazProces, int *KamenPobedaProces, int *KamenPorazProces, int *MakazePobedaProces, int *MakazePorazProces)
{
	switch(PomocnaMatrica[ID].trenutnoOruzje)
			{
				case: 0; // papir
					switch(PomocnaMatrica[k1].trenutnoOruzje)
					{
						case: 1; PomocnaMatrica[ID].brPobeda++; *PapirPobedaProces++; break;
						case: 2; PomocnaMatrica[ID].brPoraza++; *PapirPorazProces++; break;
						default: ;
					}
					switch(PomocnaMatrica[k2].trenutnoOruzje)
					{
						case: 1; PomocnaMatrica[ID].brPobeda++; *PapirPobedaProces++; break;
						case: 2; PomocnaMatrica[ID].brPoraza++; *PapirPorazProces++; break;
						default: ;
					}
					switch(PomocnaMatrica[k3].trenutnoOruzje)
					{
						case: 1; PomocnaMatrica[ID].brPobeda++; *PapirPobedaProces++;break;
						case: 2; PomocnaMatrica[ID].brPoraza++; *PapirPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k4].trenutnoOruzje)
					{
						case: 1; PomocnaMatrica[ID].brPobeda++; *PapirPobedaProces++;break;
						case: 2; PomocnaMatrica[ID].brPoraza++; *PapirPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k5].trenutnoOruzje)
					{
						case: 1; PomocnaMatrica[ID].brPobeda++; *PapirPobedaProces++;break;
						case: 2; PomocnaMatrica[ID].brPoraza++; *PapirPorazProces++;break;
						default: ;
					}
				break;
				
				case: 1; // kamen
					switch(PomocnaMatrica[k1].trenutnoOruzje)
					{
						case: 2; PomocnaMatrica[ID].brPobeda++; *KamenPobedaProces++;break;
						case: 0; PomocnaMatrica[ID].brPoraza++; *KamenPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k2].trenutnoOruzje)
					{
						case: 2; PomocnaMatrica[ID].brPobeda++; *KamenPobedaProces++;break;
						case: 0; PomocnaMatrica[ID].brPoraza++; *KamenPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k3].trenutnoOruzje)
					{
						case: 2; PomocnaMatrica[ID].brPobeda++; *KamenPobedaProces++;break;
						case: 0; PomocnaMatrica[ID].brPoraza++; *KamenPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k4].trenutnoOruzje)
					{
						case: 2; PomocnaMatrica[ID].brPobeda++; *KamenPobedaProces++;break;
						case: 0; PomocnaMatrica[ID].brPoraza++; *KamenPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k5].trenutnoOruzje)
					{
						case: 2; PomocnaMatrica[ID].brPobeda++; *KamenPobedaProces++;break;
						case: 0; PomocnaMatrica[ID].brPoraza++; *KamenPorazProces++;break;
						default: ;
					}
				break;
				
				case: 2; //makazice
					switch(PomocnaMatrica[k1].trenutnoOruzje)
					{
						case: 0; PomocnaMatrica[ID].brPobeda++; MakazePobedaProces++;break;
						case: 1; PomocnaMatrica[ID].brPoraza++; MakazePorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k2].trenutnoOruzje)
					{
						case: 0; PomocnaMatrica[ID].brPobeda++; MakazePobedaProces++;break;
						case: 1; PomocnaMatrica[ID].brPoraza++; MakazePorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k3].trenutnoOruzje)
					{
						case: 0; PomocnaMatrica[ID].brPobeda++; MakazePobedaProces++;break;
						case: 1; PomocnaMatrica[ID].brPoraza++; MakazePorazProces++;break;
						default: ;
					}
					
					switch(PomocnaMatrica[k4].trenutnoOruzje)
					{
						case: 0; PomocnaMatrica[ID].brPobeda++; MakazePobedaProces++;break;
						case: 1; PomocnaMatrica[ID].brPoraza++; MakazePorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k5].trenutnoOruzje)
					{
						case: 0; PomocnaMatrica[ID].brPobeda++; MakazePobedaProces++;break;
						case: 1; PomocnaMatrica[ID].brPoraza++; MakazePorazProces++;break;
						default: ;
					}
				break;
				default: ;
			}
	
}

void OdigrajPotez8(Igrac *PomocnaMatrica,int ID, int k1, int k2, int k3, int k4, int k5, int k6, int k7, int k8,  int *PapirPobedaProces, int *PapirPorazProces, int *KamenPobedaProces, int *KamenPorazProces, int *MakazePobedaProces, int *MakazePorazProces)
{
	switch(PomocnaMatrica[ID].trenutnoOruzje)
			{
				case: 0; // papir
					switch(PomocnaMatrica[k1].trenutnoOruzje)
					{
						case: 1; PomocnaMatrica[ID].brPobeda++; *PapirPobedaProces++;break;
						case: 2; PomocnaMatrica[ID].brPoraza++; *PapirPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k2].trenutnoOruzje)
					{
						case: 1; PomocnaMatrica[ID].brPobeda++; *PapirPobedaProces++;break;
						case: 2; PomocnaMatrica[ID].brPoraza++; *PapirPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k3].trenutnoOruzje)
					{
						case: 1; PomocnaMatrica[ID].brPobeda++; *PapirPobedaProces++;break;
						case: 2; PomocnaMatrica[ID].brPoraza++; *PapirPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k4].trenutnoOruzje)
					{
						case: 1; PomocnaMatrica[ID].brPobeda++; *PapirPobedaProces++;break;
						case: 2; PomocnaMatrica[ID].brPoraza++; *PapirPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k5].trenutnoOruzje)
					{
						case: 1; PomocnaMatrica[ID].brPobeda++; *PapirPobedaProces++;break;
						case: 2; PomocnaMatrica[ID].brPoraza++; *PapirPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k6].trenutnoOruzje)
					{
						case: 1; PomocnaMatrica[ID].brPobeda++; *PapirPobedaProces++;break;
						case: 2; PomocnaMatrica[ID].brPoraza++; *PapirPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k7].trenutnoOruzje)
					{
						case: 1; PomocnaMatrica[ID].brPobeda++; *PapirPobedaProces++;break;
						case: 2; PomocnaMatrica[ID].brPoraza++; *PapirPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k8].trenutnoOruzje)
					{
						case: 1; PomocnaMatrica[ID].brPobeda++; *PapirPobedaProces++;break;
						case: 2; PomocnaMatrica[ID].brPoraza++; *PapirPorazProces++;break;
						default: ;
					}
				break;
				
				case: 1; // kamen
					switch(PomocnaMatrica[k1].trenutnoOruzje)
					{
						case: 2; PomocnaMatrica[ID].brPobeda++; *KamenPobedaProces++;break;
						case: 0; PomocnaMatrica[ID].brPoraza++; *KamenPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k2].trenutnoOruzje)
					{
						case: 2; PomocnaMatrica[ID].brPobeda++; *KamenPobedaProces++;break;
						case: 0; PomocnaMatrica[ID].brPoraza++; *KamenPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k3].trenutnoOruzje)
					{
						case: 2; PomocnaMatrica[ID].brPobeda++; *KamenPobedaProces++;break;
						case: 0; PomocnaMatrica[ID].brPoraza++; *KamenPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k4].trenutnoOruzje)
					{
						case: 2; PomocnaMatrica[ID].brPobeda++; *KamenPobedaProces++;break;
						case: 0; PomocnaMatrica[ID].brPoraza++; *KamenPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k5].trenutnoOruzje)
					{
						case: 2; PomocnaMatrica[ID].brPobeda++; *KamenPobedaProces++;break;
						case: 0; PomocnaMatrica[ID].brPoraza++; *KamenPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k6].trenutnoOruzje)
					{
						case: 2; PomocnaMatrica[ID].brPobeda++; *KamenPobedaProces++;break;
						case: 0; PomocnaMatrica[ID].brPoraza++; *KamenPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k7].trenutnoOruzje)
					{
						case: 2; PomocnaMatrica[ID].brPobeda++; *KamenPobedaProces++;break;
						case: 0; PomocnaMatrica[ID].brPoraza++; *KamenPorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k8].trenutnoOruzje)
					{
						case: 2; PomocnaMatrica[ID].brPobeda++; *KamenPobedaProces++;break;
						case: 0; PomocnaMatrica[ID].brPoraza++; *KamenPorazProces++;break;
						default: ;
					}
				break;
				
				case: 2; //makazice
					switch(PomocnaMatrica[k1].trenutnoOruzje)
					{
						case: 0; PomocnaMatrica[ID].brPobeda++; MakazePobedaProces++;break;
						case: 1; PomocnaMatrica[ID].brPoraza++; MakazePorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k2].trenutnoOruzje)
					{
						case: 0; PomocnaMatrica[ID].brPobeda++; MakazePobedaProces++;break;
						case: 1; PomocnaMatrica[ID].brPoraza++; MakazePorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k3].trenutnoOruzje)
					{
						case: 0; PomocnaMatrica[ID].brPobeda++; MakazePobedaProces++;break;
						case: 1; PomocnaMatrica[ID].brPoraza++; MakazePorazProces++;break;
						default: ;
					}
					
					switch(PomocnaMatrica[k4].trenutnoOruzje)
					{
						case: 0; PomocnaMatrica[ID].brPobeda++; MakazePobedaProces++;break;
						case: 1; PomocnaMatrica[ID].brPoraza++; MakazePorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k5].trenutnoOruzje)
					{
						case: 0; PomocnaMatrica[ID].brPobeda++; MakazePobedaProces++;break;
						case: 1; PomocnaMatrica[ID].brPoraza++; MakazePorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k6].trenutnoOruzje)
					{
						case: 0; PomocnaMatrica[ID].brPobeda++; MakazePobedaProces++;break;
						case: 1; PomocnaMatrica[ID].brPoraza++; MakazePorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k7].trenutnoOruzje)
					{
						case: 0; PomocnaMatrica[ID].brPobeda++; MakazePobedaProces++;break;
						case: 1; PomocnaMatrica[ID].brPoraza++; MakazePorazProces++;break;
						default: ;
					}
					switch(PomocnaMatrica[k8].trenutnoOruzje)
					{
						case: 0; PomocnaMatrica[ID].brPobeda++; MakazePobedaProces++;break;
						case: 1; PomocnaMatrica[ID].brPoraza++; MakazePorazProces++;break;
						default: ;
					}
				break;
				default: ;
			}	
}

main(int argc, char *argv[])
{
	int M, N, K, UkPolja, mp, np, ukp;
	int size, id, poProcesu;
	Stat *nizStatistike;
	MPI_Status status;
	Igrac *GlavnaMatrica, *PomocnaMatrica;
	MPI_Init(&argc, &argv);
	MPI_Comm_size(MPI_COMM_WORLD, &size);
	MPI_Comm_rank(MPI_COMM_WORLD, &id);
	int PapirPobedaProces = 0, PapirPorazProces = 0, KamenPobedaProces = 0, KamenPorazProces = 0, MakazePobedaProces = 0, MakazePorazProces = 0;
	int MakazeUkPobeda = 0, MakazeUkPoraza = 0, KamenUkPobeda = 0, KamenUkPoraza = 0, PapirUkPobeda = 0, PapirUkPoraza = 0;
	
	if(id == 0)
	{
		scanf("%d%d%d", &M, &N, &K);
		nizStatistike = (Stat *)malloc(K*sizeof(Stat)); // inicijalizuje niz za statistiku
		UkPolja = M*N;
		GlavnaMatrica =  (Igrac *)malloc(UkPolja*sizeof(Igrac));
		
		poProcesu = M / size;
		mp = poProcesu + 2;
		np = N;
		
		// root salje svim procesima dimenzije njihovih podmatrica
		for(i = 1; i < size; i++)
		{
			MPI_Send(&mp, 1, MPI_INT, i, 20, MPI_COMM_WORLD);
			MPI_Send(&np, 1, MPI_INT, i, 20, MPI_COMM_WORLD);			
		}
		
		mp --; // root proces ima samo donju ghost vrstu 
		ukp = mp * np;
		
		// pomocna matrica 0. procesa, tj. njegov deo kolaca 
		PomocnaMatrica = (Igrac *)malloc(ukp*sizeof(Igrac));
		
	}
	
	else
	if (id != size - 1)  // svi drugi procesi sem poslednjeg
	{
		MPI_Recv(&mp, 1, MPI_INT, 0, 20, MPI_COMM_WORLD, &status);
		MPI_Recv(&np, 1, MPI_INT, 0, 20, MPI_COMM_WORLD, &status);
		
		ukp = mp * np;
		
		PomocnaMatrica = (Igrac *)malloc(ukp*sizeof(Igrac));
	}
	else // poslednji proces
	{
		MPI_Recv(&mp, 1, MPI_INT, 0, 20, MPI_COMM_WORLD, &status);
		MPI_Recv(&np, 1, MPI_INT, 0, 20, MPI_COMM_WORLD, &status);
		mp--; // poslednjem procesu je potrebna samo gornja ghost vrsta;
		ukp = mp * np;
		
		PomocnaMatrica = (Igrac *)malloc(ukp*sizeof(Igrac));
	}
	
	// svaki proces ima dimenzije svoje podmatrice i svoju matricu(niz)
	// krece igra
	
	for(i = 0; i < k; i++)
	{
		//u pocetku svi procesi kreiraju oruzja svojih igraca
		for(j = 0; j < ukp; j++)
		{
			x = double rand() / RANDMAX;
			if(x < 0.33) PomocnaMatrica[i].trenutnoOruzje = 0;
			else if(x < 0.66) PomocnaMatrica[i].trenutnoOruzje = 1;
			else PomocnaMatrica[i].trenutnoOruzje = 2;
		}
			
		// sad salju ghost kolone odgovarajucim susedima
		
		if(id == 0) // root proces
		{
			// salje svoju pretposlednju vrstu 1. procesu
			MPI_Send(&PomocnaMatrica[(mp-2)*np], np, Igrac, 1, 30, MPI_COMM_WORLD);
			// a prima poslednju ghost vrstu od 1. procesa
			MPI_Recv(&PomocnaMatrica[(mp-1)*np], np, Igrac, 1, 30, MPI_COMM_WORLD, &status); 
		}
		
		else 
		if(id != size -1) // procesi izmedju 0. i poslednjeg
		{
			// prihvata gornju ghost vrstu od prethodnog procesa
			MPI_Recv(&PomocnaMatrica[0], np, Igrac, id-1, 30, MPI_COMM_WORLD, &status); 
			// salje svoju 2. po redu vrstu procesu iznad cija je to ghost vrsta
			MPI_Send(&PomocnaMatrica[np], np, Igrac, id-1, 30, MPI_COMM_WORLD);
			
			// salje svoju pretposlednju vrstu procesu ispod cija je to ghost vrsta
			MPI_Send(&PomocnaMatrica[(mp-3)*np], np, Igrac, id+1, 30, MPI_COMM_WORLD);
			// a prihvata svoju donju ghost vrstu od procesa ispod
			MPI_Recv(&PomocnaMatrica[(mp-2)*np], np, Igrac, id+1, 30, MPI_COMM_WORLD, &status);
		}
		else // poslednji proces
		{
			// prima od pretposlednjeg procesa svoju gornju ghost vrstu
			MPI_Recv(&PomocnaMatrica[0], np, Igrac, id-1, 30, MPI_COMM_WORLD, &status);
			// a salje tom istom igracu svoju 2. vrstu koja je gornjem igracu donja ghost vrsta
			MPI_Send(&PomocnaMatrica[np], np, Igrac, id-1, 30, MPI_COMM_WORLD);
		}
	
		// sada svi procesi imaju svoje Igrace i njihova najsvezija oruzja za taj krug
		// pa je vreme da odigraju poteze
		
		if(id == 0)
		{
			// u 0. procesu prvo ce peske odigrati 0. i (np-1). igrac (obojica na cosku), jer nemaju gornje komsije,
			// a zatm ce kroz 2 for petlje odigrati i ostali igraci, kao i oni ivicni
			
			//Igrac sa koordinatom 0 igra
			OdigrajPotez3(PomocnaMatrica, 0, 1, np, np+1, &PapirPobedaProces, &PapirPorazProces, &KamenPobedaProces, &KamenPorazProces, &MakazePobedaProces, &MakazePorazProces);
			
			// igrac sa koordinatom np-1 igra
			OdigrajPotez3(PomocnaMatrica, np-1, np-2, 2*np-1, 2*np-2, &PapirPobedaProces, &PapirPorazProces, &KamenPobedaProces, &KamenPorazProces, &MakazePobedaProces, &MakazePorazProces);	
			
			// igraju igraci iz prvog reda sem krajnjih
			for(j = 1; j < np-1; j++)
			OdigrajPotez5(PomocnaMatrica, j, j-1, j+1, j+np-1, j+np, j+np+1, &PapirPobedaProces, &PapirPorazProces, &KamenPobedaProces, &KamenPorazProces, &MakazePobedaProces, &MakazePorazProces);
			
			// igraju igraci iz leve i desne ivicne kolone sem ovih na coskovima
			for(j = 1; j < mp-1; j++)
				{
					OdigrajPotez5(PomocnaMatrica, j*np, (j-1)*np,(j-1)*np+1, j*np+1, (j+1)*np, (j+1)*np+1, &PapirPobedaProces, &PapirPorazProces, &KamenPobedaProces, &KamenPorazProces, &MakazePobedaProces, &MakazePorazProces); // prva kolona sa leve strane
					OdigrajPotez5(PomocnaMatrica, (j+1)*np-1, (j+1)*np-2, (j+2)*np-1, (j+2)*np-2, j*np-1, j*np-1, &PapirPobedaProces, &PapirPorazProces, &KamenPobedaProces, &KamenPorazProces, &MakazePobedaProces, &MakazePorazProces); // poslednja kolona, sa desne strane
				}
			
			// igraju centralni igraci, svi koji imaju 8 komsija
			for(g = 1; g < mp-1; g++)
				for(j = 1; j < np-1; j++)
					OdigrajPotez8(PomocnaMatrica, g*np+j, g*np+j-1, g*np+j+1,(g-1)*np+j-1, (g-1)*np+j, (g-1)*np+j+1, (g+1)*np+j-1, (g+1)*np+j, (g+1)*np+j+1, &PapirPobedaProces, &PapirPorazProces, &KamenPobedaProces, &KamenPorazProces, &MakazePobedaProces, &MakazePorazProces);
		}
		
		else
		if(id != size-1) // svi procesi se poslednjeg
		{
			// igraju igraci iz leve i desne ivicne kolone sem ovih na coskovima
			for(j = 1; j < mp-1; j++)
				{
					OdigrajPotez5(PomocnaMatrica, j*np, (j-1)*np,(j-1)*np+1, j*np+1, (j+1)*np, (j+1)*np+1, &PapirPobedaProces, &PapirPorazProces, &KamenPobedaProces, &KamenPorazProces, &MakazePobedaProces, &MakazePorazProces); // prva kolona sa leve strane
					OdigrajPotez5(PomocnaMatrica, (j+1)*np-1, (j+1)*np-2, (j+2)*np-1, (j+2)*np-2, j*np-1, j*np-1, &PapirPobedaProces, &PapirPorazProces, &KamenPobedaProces, &KamenPorazProces, &MakazePobedaProces, &MakazePorazProces); // poslednja kolona, sa desne strane
				}
		
			// igraju centralni igraci, svi koji imaju 8 komsija
			for(g = 1; g < mp-1; g++)
				for(j = 1; j < np-1; j++)
					OdigrajPotez8(PomocnaMatrica, g*np+j, g*np+j-1, g*np+j+1,(g-1)*np+j-1, (g-1)*np+j, (g-1)*np+j+1, (g+1)*np+j-1, (g+1)*np+j, (g+1)*np+j+1, &PapirPobedaProces, &PapirPorazProces, &KamenPobedaProces, &KamenPorazProces, &MakazePobedaProces, &MakazePorazProces);
		}
		else // poslednji proces
		{
		    // u poslednjem procesu prvo ce peske odigrati igraci na coskovima jer nemaju donje komsije,
			// a zatm ce kroz 2 for petlje odigrati i ostali igraci, kao i oni ivicni
			
			//Igrac sa koordinatom (mp-1)*np igra
			OdigrajPotez3(PomocnaMatrica, (mp-1)*np, (mp-1)*np+1, (mp-2)*np, (mp-2)*np+1, &PapirPobedaProces, &PapirPorazProces, &KamenPobedaProces, &KamenPorazProces, &MakazePobedaProces, &MakazePorazProces);
			
			// igrac sa koordinatom mp*np-1 igra
			OdigrajPotez3(PomocnaMatrica, mp*np-1, mp*np-2, (mp-1)*np-1, (mp-1)*np-2, &PapirPobedaProces, &PapirPorazProces, &KamenPobedaProces, &KamenPorazProces, &MakazePobedaProces, &MakazePorazProces);	
			
			// igraju igraci iz poslednjeg reda sem krajnjih
			for(j = 1; j < np-1; j++)
			OdigrajPotez5(PomocnaMatrica, (mp-1)*np+j, (mp-1)*np+j-1, (mp-1)*np+j+1, (mp-2)*np+j-1, (mp-2)*np+j, (mp-2)*np+j+1, &PapirPobedaProces, &PapirPorazProces, &KamenPobedaProces, &KamenPorazProces, &MakazePobedaProces, &MakazePorazProces);
			
			// igraju igraci iz leve i desne ivicne kolone sem ovih na coskovima
			for(j = 1; j < mp-1; j++)
				{
					OdigrajPotez5(PomocnaMatrica, j*np, (j-1)*np,(j-1)*np+1, j*np+1, (j+1)*np, (j+1)*np+1, &PapirPobedaProces, &PapirPorazProces, &KamenPobedaProces, &KamenPorazProces, &MakazePobedaProces, &MakazePorazProces); // prva kolona sa leve strane
					OdigrajPotez5(PomocnaMatrica, (j+1)*np-1, (j+1)*np-2, (j+2)*np-1, (j+2)*np-2, j*np-1, j*np-1, &PapirPobedaProces, &PapirPorazProces, &KamenPobedaProces, &KamenPorazProces, &MakazePobedaProces, &MakazePorazProces); // poslednja kolona, sa desne strane
				}
			
			// igraju centralni igraci, svi koji imaju 8 komsija
			for(g = 1; g < mp-1; g++)
				for(j = 1; j < np-1; j++)
					OdigrajPotez8(PomocnaMatrica, g*np+j, g*np+j-1, g*np+j+1,(g-1)*np+j-1, (g-1)*np+j, (g-1)*np+j+1, (g+1)*np+j-1, (g+1)*np+j, (g+1)*np+j+1, &PapirPobedaProces, &PapirPorazProces, &KamenPobedaProces, &KamenPorazProces, &MakazePobedaProces, &MakazePorazProces);
		}
		
	// svi su odigrali svoje poteze, sad samo statistika treba da odradi svoje, da sakupi sve podatke kod sebe. svaki proces ce da izracuna
		MPI_Reduce(PapirPobedaProces, PapirUkPobeda, 1, MPI_INT, MPI_SUM, 0, MPI_COMM_WORLD);
		MPI_Reduce(PapirPorazProces, PapirUkPoraza, 1, MPI_INT, MPI_SUM, 0, MPI_COMM_WORLD);
		
		MPI_Reduce(KamenPobedaProces, KamenUkPobeda, 1, MPI_INT, MPI_SUM, 0, MPI_COMM_WORLD);
		MPI_Reduce(KamenPorazProces, KamenUkPoraza, 1, MPI_INT, MPI_SUM, 0, MPI_COMM_WORLD);
		
		MPI_Reduce(MakazePobedaProces, MakazeUkPobeda, 1, MPI_INT, MPI_SUM, 0, MPI_COMM_WORLD);
		MPI_Reduce(MakazePorazProces, MakazeUkPoraza, 1, MPI_INT, MPI_SUM, 0, MPI_COMM_WORLD);
		
		if(id == 0)
		{
			nizStatistike[k].br_pobedaPapir = PapirUkPobeda;
			nizStatistike[k].br_porazaPapir = PapirUkPoraza;
			
			nizStatistike[k].br_pobedaKamen = KamenUkPobeda;
			nizStatistike[k].br_porazaKamen = KamenUkPoraza;
			
			nizStatistike[k].br_pobedaMakaze = MakazeUkPobeda;
			nizStatistike[k].br_porazaMakaze = MakazeUkPoraza;
		}
	
	}
	
	// zatim sakuplja nazad kod sebe matrice drugih procesa, da bi nasao najboljeg igraca
	//Nisam imao vremena da nadjem maksimalnog igraca. Procedura je sledeca. Pomocu MPI_Gather sakupimo u root procesu kompletnu matricu svih igraca. Onda on lako izvrsi prolazak kroz istu, i nadje najboljeg igraca	
	
	if(id == 0)
	{	
		// 0. proces ispisuje statistiku za svaki krug
		for(i = 0; i < k; i++)
		printf("%d. krug. | PAPIR: %d pobeda i %d poraza\t| KAMEN: %d pobeda i %d poraza\t| MAKAZICE: %d pobeda i %d poraza\n", i, nizStatistike[i].br_pobedaPapir, nizStatistike[i].br_porazaPapir,
		nizStatistike[i].br_pobedaKamen, nizStatistike[i].br_porazaKamen, nizStatistike[i].br_pobedaMakaze, nizStatistike[i].br_porazaMakaze);
	}
	
	MPI_Finalize();
	
	
}
















