#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
#include <time.h>

typedef struct s_stat {
	int oruzje;
	int br_pobeda;
	int br_poraza;	
} Stat;

typedef struct s_igrac {
	int br_pobeda;
	int br_poraza;
	int trenutno_oruzje;
} Igrac;

void SumStat(Stat *in, Stat *inout, int *len, MPI_Datatype *type) {
	int i;
	for (i = 0; i < *len; i++) {
		*inout[i].br_pobeda += *in[i].br_pobeda;
		*inout[i].br_poraza += *in[i].br_poraza;
		in++;
		inout++;
	}
}

main(int argc, char **argv) {
	
	int myid, np, i, j;
	
	MPI_Init(&argc, &argv);
	MPI_Comm_size(MPI_COMM_WORLD, &np);
	MPI_Comm_rank(MPI_COMM_WORLD, &myid);
	MPI_Status status;
	
	MPI_Datatype stat, ig;
	MPI_Datatype oldtypes[] = {MPI_INT};
	MPI_Aint offsets[] = {0};
	int blockcounts[] = {3};
	MPI_Type_struct(1, blockcounts, offsets, oldtypes, &stat);
	MPI_Type_commit(&stat);
	MPI_Type_struct(1, blockcounts, offsets, oldtypes, &ig);
	MPI_Type_commit(&ig);
	
	MPI_Op ss;
	MPI_Op_create((MPI_User_function *)SumStat, 1, &ss);
	
	srand(time(NULL));
	
	Stat **matrica;
	
	if (myid == 0) {
		scanf("%d", &m);
		scanf("%d", &n);
		scanf("%d", &k);		
		
		// alokacija matrice
		matrica = (Stat **)malloc(m * sizeof(Stat*));
		for (i = 0; i < m; i++) {
			matrica[i] = (Stat *)malloc(n * sizeof(Stat));
		}
		
		for (i = 0; i < m; i++) {
			for (j = 0; j < n; j++) {
				matrica[i][j].oruzje = rand() % 3;
				matrica[i][j].br_pobeda = 0;
				matrica[i][j].br_poraza = 0;
			}
		}		
	}
	
	while (i < k) {
	
		// podeli svima matricu sa ghost kolonama
		
		// takmici se sa susedima		
		
	}
	
	// odradi statistiku pomocu reduce funkcije SumStat, moja ss
	
	// odstampati pozicije igraca sa najvise pobeda
	
	MPI_Finalize();
	return 0;	
}


